CREATE PROCEDURAL LANGUAGE plpgsql;
ALTER PROCEDURAL LANGUAGE plpgsql OWNER TO postgres;

create table flat_table (gid integer, val integer);

insert into flat_table(gid, val) values (1, 1);
insert into flat_table(gid, val) values (1, 2);
insert into flat_table(gid, val) values (1, 3);
insert into flat_table(gid, val) values (1, 4);
insert into flat_table(gid, val) values (1, 5);
insert into flat_table(gid, val) values (1, 6);
insert into flat_table(gid, val) values (1, 7);
insert into flat_table(gid, val) values (1, 8);
insert into flat_table(gid, val) values (1, 9);
insert into flat_table(gid, val) values (1, 10);
insert into flat_table(gid, val) values (1, 11);
insert into flat_table(gid, val) values (1, 12);
insert into flat_table(gid, val) values (1, 13);
insert into flat_table(gid, val) values (1, 14);
insert into flat_table(gid, val) values (1, 15);

insert into flat_table(gid, val) values (2, 1);
insert into flat_table(gid, val) values (2, 2);
insert into flat_table(gid, val) values (2, 3);
insert into flat_table(gid, val) values (2, 4);
insert into flat_table(gid, val) values (2, 5);
insert into flat_table(gid, val) values (2, 6);
insert into flat_table(gid, val) values (2, 7);
insert into flat_table(gid, val) values (2, 8);
insert into flat_table(gid, val) values (2, 9);
insert into flat_table(gid, val) values (2, 10);
insert into flat_table(gid, val) values (2, 11);
insert into flat_table(gid, val) values (2, 12);
insert into flat_table(gid, val) values (2, 13);
insert into flat_table(gid, val) values (2, 14);
insert into flat_table(gid, val) values (2, 15);

CREATE FUNCTION aggregate_array_max10(anyarray, anyelement) RETURNS anyarray
    LANGUAGE sql
    AS $_$
SELECT
CASE
WHEN $1 IS NULL
THEN ARRAY[$2]
WHEN $2 IS NULL
THEN $1
WHEN array_length($1, 1) >= 10
THEN $1
ELSE array_append($1,$2)
END;
$_$;

ALTER FUNCTION public.aggregate_array_max10(anyarray, anyelement) OWNER TO postgres;

CREATE AGGREGATE aggarray_max10(anyelement) (
    SFUNC = aggregate_array_max10,
    STYPE = anyarray
);

ALTER AGGREGATE public.aggarray_max10(anyelement) OWNER TO postgres;

CREATE TYPE custom_type AS (gid integer, int_array integer[]);

CREATE FUNCTION get_as_int_array() RETURNS SETOF custom_type
    LANGUAGE plpgsql STABLE
    AS $$
BEGIN
 RETURN QUERY SELECT gid AS gid, aggarray_max10(flat_table.val) AS int_array FROM flat_table GROUP BY gid;
END;
$$;

ALTER USER postgres WITH ENCRYPTED PASSWORD 'password';

